=== AMP for WP - Accelerated Mobile Pages ===
Contributors: mohammed_kaludi, ahmedkaludi, ampforwp
Tags: AMP, accelerated mobile pages, mobile, amp project, google amp, amp wp, google, plugin, SEO
Donate link: https://www.paypal.me/Kaludi/25
Requires at least: 3.0
Tested up to: 5.3.2
Stable tag: 1.0.31
License: GPLv2 or later
License URI: http://www.gnu.org/licenses/gpl-2.0.html

AMP for WP is the most recommended AMP plugin by the community. Automatically add Accelerated Mobile Pages (Google AMP Project) functionality on your WordPress site.

== Description ==
AMP for WP automatically adds Accelerated Mobile Pages (Google AMP Project) functionality to your WordPress site. AMP makes your website faster for Mobile visitors.

[What's New in this Version?](https://ampforwp.com/new/) | [Priority Support](https://ampforwp.com/priority-support/#utm_source=wp_org&utm_medium=description-tab-pro-box&utm_campaign=AMP%20Plugin) | [View Demo](https://ampforwp.com/demo/) | [Screenshots](https://wordpress.org/plugins/accelerated-mobile-pages/screenshots/) | [Community](https://ampforwp.com/help-center/)

<strong>Extensions</strong><br>
Some useful extensions to extend AMP features, check [AMP Adsense Support](https://ampforwp.com/advanced-amp-ads/#utm_source=wp_org&utm_medium=description-tab-pro-box&utm_campaign=AMP%20Plugin), [Contact Form 7 Support](https://ampforwp.com/contact-form-7/#utm_source=wp_org&utm_medium=description-tab-pro-box&utm_campaign=AMP%20Plugin), [Email Opt-in Support](https://ampforwp.com/opt-in-forms/#utm_source=wp_org&utm_medium=description-tab-pro-box&utm_campaign=AMP%20Plugin) and [Call To Action Support](https://ampforwp.com/call-to-action/#utm_source=wp_org&utm_medium=description-tab-pro-box&utm_campaign=AMP%20Plugin). To view more, go to our [Extensions page](https://ampforwp.com/extensions/#utm_source=wp_org&utm_medium=description-tab-pro-box&utm_campaign=AMP%20Plugin).

<strong>Support</strong><br>
We try our best to provide support on WordPress.org forums. However, We have a special [community support](https://ampforwp.com/help-center/) where you can ask us questions and get help about your AMP related questions. Delivering a good user experience means a lot to us and so we try our best to reply each and every question that gets asked.

<strong>Bug Reports</strong><br>
Bug reports for AMP for WP are [welcomed on GitHub](https://github.com/ahmedkaludi/Accelerated-Mobile-Pages). Please note GitHub is _not_ a support forum, and issues that aren't properly qualified as bugs will be closed.


= Features: =

* NEW - Gutenberg Support
* NEW - Divi and Elementor Support [More Info](https://ampforwp.com/amp-pagebuilder-compatibility/)
* NEW - Improved CSS Optimization (Tree Shaking)
* NEW - Google Fonts Support For All Designs
* NEW - Addthis Sharing Support
* NEW - AMP Infinite Scroll Support
* NEW - Photo Gallery by 10Web Support 
* NEW - MEWE social network Support 
* NEW - GDPR Compliance
* Out of the box compatiblity for Yoast SEO, All in One Seo, Rank Math, Genesis, SEOPress, Bridge Qode SEO, The SEO Framework and Squrilly SEO Plugin.
* Introducing Page Builder 3.0 for AMP! [Learn More & Video](https://ampforwp.com/tutorials/article/amp-page-builder-installation/)
* New Default Theme for AMP called Swift
* 3 Pre-built AMP Layouts for Business websites and landing pages 
* OneSignal Push Notifications integration 
* Advanced WooCommerce Support [More Info](https://ampforwp.com/woocommerce/)
* Gravity Forms Support [More Info](https://ampforwp.com/gravity-forms/)
* AMP Plugins Manager - Which allows you to disable a specific plugin functionality only in the AMP version
* Structured Data Options
* Page Break / NextPage (Pagination) Support
* Contact Form 7 Support [More Info](https://ampforwp.com/contact-form-7/)
* Graviry Form Support [More Info](https://ampforwp.com/gravity-forms/)
* Caldera Form Support [More Info](https://ampforwp.com/caldera-forms-for-amp/)
* Ninja Form Support [More Info](https://ampforwp.com/ninja-forms/)
* Facebook Comments Support
* Github Gist Support
* Email Opt-in Subscription form support in AMP added
* Call to Action boxes and notification bars 
* 9 Advertisement sizes - 2 More AD slots added recently
* Comments Forms in AMP.
* Native AMP Search functionality.
* Design 3 [Watch the Video Overview](https://www.youtube.com/watch?v=ub1pwskt3Rc)
* Disqus Comments Support
* Google Tag Manager Support
* Page, Category & Tags Support Added
* Custom AMP Editor - Which allows you to override your Content that you had written in Post or page, so you can add the different content just for AMP.
* Mobile Redirection -  More than 50% of your traffic is from mobile and you aren’t doing anything to improve their user experience, which means you are falling behind on SEO and it can result in lower SERPS. Lightning fast mobile version means faster User experience means more engagement which directly results in the lower bounce rate.
* Custom Post Type Support 
* Star Ratings
* Drag & Drop Page builder Added 
* 4 Designs for AMP 
* AMP WooCommerce Support 
* Switch on/off Support for Pages & Posts on AMP
* Translation Panel & RTL
* Internal AMP linking - You can browse AMP pages internally
* Related posts below the post
* Recent Comments list
* Automatically integrate AMP to your website.
* Google Adsense (AMP-AD) Support with 4 different Ad slots across the layout! The First Plugin to have this capability.
* Built in MGID Ads Support with 6 different ad slots.
* Google Analytics Support.
* User Friendly Theme Options Panel.
* Unlimited Color Scheme.
* Image Logo Upload.
* Supports Posts and Pages and other custom post types.
* Proper rel canonical tags which means that Google know the original page.
* Overlay Navigation Menu bar.
* Social Sharing in the Single.
* Sexy Design.
* Separate WordPress Menu for AMP version.
* Page builder & Shortcodes Compatibility.
* Carousel support for Gallery.
* Better Image stretching and resizing.
* Youtube Video Embed Support.
* Vine Embed Support.
* Twitter oembed Support.
* Instagram Embed Support.
* Facebook Video Embed Support.
* RTL Support
* Custom AMP FrontPage
* Notifications
* Alexa Metrics, Chartbeat, Hi-stats, Yandex Metrika, Piwik, Segment.com, StatCounter, Effective Measure and comScore Builtin Support
* Incontent & DoubleClick Support
* Great Support & Active Development.
* Widgets & WooCommerce 
* Breadcrumb Support added 
* Facebook Instant Articles Support Added
* AMP Installation Wizard that makes it easy to setup for new users.
* Category base remover support
* Tag base remover support
* 7 New Social Media Integrations added (Reddit, Tumblr, Telegram, Digg, StumbleUpon, Wechat, Viber) 
* AMP Theme Framework Core Support Added. You can now create AMP templates of your own in just minutes. **[More](https://ampforwp.com/amp-theme-framework/)**
* NEW - Make AMP & Non-AMP Same with just one click! 
* NEW - Allows you to use AMP as primary website!


**[JOIN CHAT GROUP COMMUNITY](https://ampforwp.com/community/)**: Purpose of this group is to get proper suggestions and feedback from plugin users and the community so that we can make the plugin even better.

= Getting Started: =
**[1. User Documentation:](https://ampforwp.com/help/)** The AMP for WordPress plugin is easy to setup but we have some tutorials and guides prepared for you which will help you dive deep with the plugin.

**[2. Developer Docs:](https://ampforwp.com/tutorials/article-categories/developer-documentation/)** We have created special documentations for developers and semi technical users who are willing to modify the plugin according to their own needs.

**[3. Support:](https://ampforwp.com/help-center/)** We try our best to provide support on WordPress.org forums. However, We have a special community support where you can ask us questions and get help about your AMP related questions. Delivering a good user experience means a lot to us and so we try our best to reply each and every question that gets asked.

**[4. Premium Support:](https://ampforwp.com/priority-support/#utm_source=wp_org&utm_medium=description-tab-pro-box&utm_campaign=AMP%20Plugin)** We will personally take care that your website’s AMP version is perfectly validated. We will make sure that your AMP version gets approved and indexed by Google Webmaster Tools properly and we will even keep an eye on AMP updates from Google and implement them into your website.

== Credits ==
Some code used in this plugin was forked from 'AMP for WordPress' plugin https://wordpress.org/plugins/amp/ - License URI: http://www.gnu.org/licenses/gpl-2.0.html.
Mobile & Tablet detection library used https://github.com/serbanghita/Mobile-Detect - License URI: https://github.com/serbanghita/Mobile-Detect/blob/master/LICENSE.txt
PHP CSS Parser library used https://github.com/sabberworm/PHP-CSS-Parser - License URI: https://github.com/sabberworm/PHP-CSS-Parser#license (PHP-CSS-Parser is freely distributable under the terms of an MIT-style license.)

== Installation ==
**[Visit Help area for the Documentation:](https://ampforwp.com/help/)**

[youtube https://www.youtube.com/watch?v=Em1nsE_KaKw]

**[Visit Help area for the Documentation:](https://ampforwp.com/help/)**


== Frequently Asked Questions ==

= Can I add analytics? =

Yes, you easily can. In fact, we have support for 12 Analytics companies. Including Google Analytics, Facebook Pixel, StatCounter, QuantCast, Chartbeat, comScore to list a few. Also, we have Google Tag Manager (GTM) support as well.

= Can I add Ads in my AMP pages? =

Yes, you can. We have 6 ad placement slots that are built in and strategically placed to get maximum views. Also, we have [an extension](https://ampforwp.com/advanced-amp-ads/) from which you can insert ads between the content, will get more ad slots and also add custom banners to all the available slots.


= Can I extend/Change the AMP design, so it suits my needs? =

Yes, you easily can. We have created this plugin in such a way that it can easily be extended. Check out our [AMP Theme Framework](https://ampforwp.com/tutorials/article/getting-started-amp-framework/)


= Do you have any prebuilt designs? =

Yes, we have AMP themes section where we have free and paid designs available. We also update it regularly. You can check it out our [AMP Themes](https://ampforwp.com/themes)


= I'm a developer and I want to add custom functionality for a client, can I do that? =

Yes, of course. This plugin is very developer friendly, we have lots of hooks and filters that you can use to extend and customize according to the requirements. Also, we have [developer documentation](https://ampforwp.com/tutorials/article-categories/developer-documentation/) which we update regularly.


= How do I report bugs and suggest new features? =

You can report the bugs [here](https://github.com/ahmedkaludi/Accelerated-Mobile-Pages/issues)

= Will you Add New features to my request? =

Yes, Absolutely! We would suggest you send your feature request by creating an issue in [Github](https://github.com/ahmedkaludi/Accelerated-Mobile-Pages/issues/new/) . It helps us organize the feedback easily.


= How do I get in touch? =

You can contact us from [here](https://ampforwp.com/contact/)


== Screenshots ==
1. AMP Homepage
2. AMP Single Post
3. Post Navigation in Single
4. Sticky Social sharing icons
5. Overlay Navigation menu sidebar.
6. Page builder of the Single article. You can drag and drop any element.
7. Single post of Design One
8. GTMetrix Performance Report
9. Google PageSpeed Insight report for AMP
10. Homepage of Design One
11. Pingdom Speed Report for AMP

Device testing done through [BrowserStack](https://www.browserstack.com)
![BrowserStack](https://user-images.githubusercontent.com/16618009/53022655-a24ea780-3481-11e9-9a48-a2ca5bcd96d6.png)

== Changelog ==

= 1.0.31 (28th February 2020) =
* Improvement: Added option to hide vukkle comments emoji #4194
* Improvement: Added alt for images in Slider module of AMP page builder #4193
* Improvement: Updated sabberworm folder #4142
* Fixed: Fatal Error fixed with zombify plugin #4184
* Fixed: Validation error due to Mediavine Plugin #4206
* Fixed: Instant article bug #4150
* Fixed: AMP Search Not Working with Betheme #4195
* Fixed: StackPath CDN not working #4123
* Fixed: Extra 301 redirect after enabling ?amp #4167
* Fixed: Table CSS improved #4185
* Fixed: Debug Warnings #4226
* Fixed: AMP Option panel improvements #4202 #4219

= 1.0.30 (24th February 2020) =
* Improvement: Added Autoplay in Image Gallery #3705
* Fixed: Jetpack lazy loading not working due to our AMPforWP plugin #4183
* Fixed: Amp comments Bug with update 1.0.28 #4209
* Fixed: Removed Table styles when AMP Pagebuilder compatibility plugin is active #4185
* Fixed: Debug warning fixed #4204 #4212

= 1.0.29 (21th February 2020) =
* Improvement: Created an option for entering URLs to prefetch. #3997
* Fixed: Admin bar css is not loaded on amp pages #4130
* Fixed: Optimize amp pages and CSS #3579 #4174
* Fixed: When the tree shaking is enabled then the CSS of the layouts break #4113
* Fixed: Extra 301 redirect after enabling ?amp #4167
* Fixed: Break in layout when AMP takeout and conver to wp is enabled together #4176
* Fixed: There should be no notices or messages from other third party plugins on the AMP option panel. #4166
* Fixed: Incorrect time showing on AMP if we select Timezone as UTC-3 #4160
* Fixed: WPappbox images are not loading on the amp pages #4161
* Fixed: CSS of CTA button is over-riding while using more than one CTA  in AMP pagebuilder. #4173
* Fixed: Notice Errors - Trying to get property 'title' #4196
* Fixed: Warning issue on AMP option panel. #4172
* Fixed: Display the Search button in AMP option panel. #4165
* Fixed: Warning Errors #4200
* Fixed: amp-access script is not being appended via Enter HTML in Head #4199
* Fixed: Issues related to category support on the AMP Pages #4151
* Fixed: AMP Options panel UI bugs #4180 #4179 #4105

= 1.0.28 (18th February 2020) =
* Improvement: Scripts added from Options panel should have higher priority in the frontend #4064

= 1.0.27 (16th February 2020) =
* Fixed: Bugs in Imagify plugin #3908
* Fixed: GDPR popup not blocking header #4155
* Fixed: Save button dissappers when clicked on setup settings #4169
* Fixed: Alignment issue when there is no caption on featured image #4171
* Fixed: Whitelisted Picture tag #4051
* Fixed: Show/Hide Slider or Icon module in AMP Pagebuilder is not clickable #4153
* Fixed: Debug warning when empty item added in Slider module in AMP pagebuilder #4152
* Fixed: Empty link in facebook share in sticky bar #4154
* Fixed: AMP Options panel UI bugs #4122 #4162

= 1.0.26 (13th February 2020) =
* Improvement: import/export option improved #4089
* Fixed: Added option to show/hide featured image on AMP pagebuilder #4131
* Fixed: AMP Options panel UI bug #4122

= 1.0.25 (12th February 2020) =
* Fixed: Title issue #4138

= 1.0.24 (11th February 2020) =
* Improvement: Added filter to modify the breadcrumb homepage url #4077
* Fixed: Image alignment on the left issue #4156
* Fixed: H1 tag not appearing on posts #4121
* Fixed: "Title on static page front page" option not working #4138
* Fixed: AMP Menu option was not showing in WP settings #4129
* Fixed: Blank Events Calendar Months Page when 'Minify' option is enabled #4080
* Fixed: Removed '@' in Twitter Handle #4135
* Fixed: Message improved when "Leverage Browser Caching" option is enable without readable or writable permission of htaccess file  #4127
* Fixed: Featured image removed on AMP Pagebuilder pages #4131

= 1.0.23 (7th February 2020) =
* Fixed: Fatal error in amp theme framework if WordPress directory is modified #4145
* Fixed: Iframe error due to Jetpack #4125
* Fixed: Menu transient increased to avoid deadlock error #4133
* Fixed: Moved "Breadcrumbs From Yoast" to SEO option Panel section. #3600
* Fixed: Featured Image from the content is not fetching the image when height and width is not present in the image code in Classic editor. #4096
* Improvement: Sorting option for Pagebuilder slider/gallery #2014
* Improvement: Option for showing no. of words in the excerpt of Recent Posts and Related Posts #3640
* Improvement: Link Comments section with comments order #3740
* Improvement: Default fallback images Added #3719
* Improvement: subscript<sub> and superscript<sup> support #4137
* Improvement: Message added if no seo option is selected but seo plugin is active #4124

= 1.0.22 (6th February 2020) =
* Fixed: Console error - Uncaught TypeError: Cannot read property 'on' of null #4102
* Fixed: When Insert post ads plugin is enable then AMP settings panel is not showing. #4107
* Fixed: Search console error fixed on WooCommerce wishlist page #4097
* Fixed: GTM Added in Basic Setup and code improvements #4108
* Fixed: The meta tags was not working in Head section #4116
* Fixed: Upgrade to Pro button was missing in the AMP setting panel #4118
* Fixed: Upgrade to Pro option was removing in the setting panel when we activate PWA for WP plugin #4117
* Fixed: FAQ section improved #4119

Full changelog available [ at changelog.txt](https://plugins.svn.wordpress.org/accelerated-mobile-pages/trunk/changelog.txt)