<?php

if(is_plugin_active( 'amp/amp.php' )){
$args = array(
    // TYPICAL -> Change these values as you need/desire
    'opt_name'              => 'redux_builder_amp', // This is where your data is stored in the database and also becomes your global variable name.
    'display_name'          =>  __( 'AMPforWP AMP optin Options','accelerated-mobile-pages' ), // Name that appears at the top of your panel
    'menu_type'             => 'menu', //Specify if the admin menu should appear or not. Options: menu or submenu (Under appearance only)
    'allow_sub_menu'        => true, // Show the sections below the admin menu item or not
    'menu_title'            => __( 'AMP Optin', 'accelerated-mobile-pages' ),
    'page_title'            => __('AMP Optin','accelerated-mobile-pages'),
    'global_variable'       => '', // Set a different name for your global variable other than the opt_name
    'dev_mode'              => false, // Show the time the page took to load, etc
    'customizer'            => false, // Enable basic customizer support,
    'async_typography'      => false, // Enable async for fonts,
    'disable_save_warn'     => true,
    'open_expanded'         => false,
    // OPTIONAL -> Give you extra features
    'page_priority'         => null, // Order where the menu appears in the admin area. If there is any conflict, something will not show. Warning.
    'page_parent'           => 'themes.php', // For a full list of options, visit: http://codex.wordpress.org/Function_Reference/add_submenu_page#Parameters
    'page_permissions'      => 'manage_options', // Permissions needed to access the options panel.
    'last_tab'              => '', // Force your panel to always open to a specific tab (by id)
    'page_icon'             => 'icon-themes', // Icon displayed in the admin panel next to your menu_title
    'page_slug'             => 'amp_optin_options', // Page slug used to denote the panel
    'save_defaults'         => true, // On load save the defaults to DB before user clicks save or not
    'default_show'          => false, // If true, shows the default value next to each field that is not the default value.
    'default_mark'          => '', // What to print by the field's title if the value shown is default. Suggested: *
    'admin_bar'             => false,
    'admin_bar_icon'        => 'dashicons-admin-generic', 
    // CAREFUL -> These options are for advanced use only
    'output'                => false, // Global shut-off for dynamic CSS output by the framework. Will also disable google fonts output
    'output_tag'            => false, // Allows dynamic CSS to be generated for customizer and google fonts, but stops the dynamic CSS from going to the head
    //'domain'              => 'redux-framework', // Translation domain key. Don't change this unless you want to retranslate all of Redux.
    'footer_credit'         => false, // Disable the footer credit of Redux. Please leave if you can help it.
    'footer_text'           => "",
    'show_import_export'    => false,
    'system_info'           => true,

);

    $args['share_icons'][] = array(
        'url'   => 'https://github.com/ahmedkaludi/Accelerated-Mobile-Pages',
        'title' => __('Visit us on GitHub','accelerated-mobile-pages'),
        'icon'  => 'el el-github'
        //'img'   => '', // You can use icon OR img. IMG needs to be a full URL.
    );


Redux::setArgs( "redux_builder_amp", $args );
}

if ( ! function_exists( 'ampoptin_settings_page' ) ) {
	function ampoptin_settings_page($sections){
		$sections[] = array(
		      'title'      => __( 'AMP Optin', 'accelerated-mobile-pages' ),
		      'id'         => 'ampforwp-optin-subsection',
		      // 'subsection' => true,
		      'icon' => 'el  el-envelope ',
		      'desc'  => ''
		);

		$sections[] = array(
					'title'      => __( 'Introduction', 'redux-framework-demo' ),
					'id'				=> 'ampoptin-introduction',
					'desc' => '<h3>Welcome to AMP Opt-in</h3>
		            
		            <p>This extension has several options for you. There are two main sections of this plugin.</p>
		            <p>1. Opt-in forms section allows you to create the opt-in form from the selected company. You can access this area from left sidebar called AMP Optin. </p>
		            <p>2. Second part of this extension is this options panel. Here, you will find two setting tabs, Style and Position. From the Style, you can change the look and feel of the form with the help of color pickers. The Position tab has options that allows you to display the optin forms globally.</p>    
		            <p><b>Quick Tutorial links:</b>
		            <ul>
		            <li>1. <a href="http://ampforwp.com/tutorials/optin-forms-in-amp/">How to create opt-in form in AMP?</a></li>
		            <li>2. <a href="http://ampforwp.com/tutorials/mailchimp-in-amp/">How to create Mailchimp form in AMP?</a></li>
		            <li>3. <a href="http://ampforwp.com/tutorials/getresponse-in-amp/">How to create GetResponse form in AMP?</a></li>
		            <li>4. <a href="http://ampforwp.com/tutorials/campaignmonitor-in-amp/">How to create Campaign Monitor form in AMP?</a></li>
		            <li>5. <a href="http://ampforwp.com/tutorials/mailerlite-in-amp/">How to create Mailerlite form in AMP?</a></li>
		            </ul></p>
		            ',
					'subsection' => true
						);

		$sections[] = array(
					'title'      => __( 'Style', 'redux-framework-demo' ),
					'desc'       => __( '', 'redux-framework-demo'),
					'id'				=> 'ampoptin-color-section',
					'subsection' => true,
								'fields'		=> array(
		                array(
		                        'id'        => 'amp_option_form_bg_color',
		                        'type'      => 'color_rgba',
		                        'title'     => 'Background Color', 
		                        'default'   => array( 'color' => '#f3f9fe'),
		                        ),
		                array(
		                        'id'        => 'amp_option_form_headline_color',
		                        'type'      => 'color_rgba',
		                        'title'     => 'Headline Color',
		                        'default'   => array( 'color' => '#0087E2'),
		                        ),
		                array(
		                        'id'        => 'amp_option_form_text_color',
		                        'type'      => 'color_rgba',
		                        'title'     => 'Form Text Color',
		                        'default'   => array( 'color' => '#7c7c7c'),
		                        ),
		                array(
		                        'id'        => 'amp_option_button_bg_color',
		                        'type'      => 'color_rgba',
		                        'title'     => 'Button Background Color',
		                        'default'   => array( 'color' => '#0087E2'),
		                        ),
		                array(
		                        'id'        => 'amp_option_button_text_color',
		                        'type'      => 'color_rgba',
		                        'title'     => 'Button Text Color',
		                        'default'   => array(
		                                'color'     => '#ffffff',
		                        ),
		                    ),
			),
		);

		$args = array(
			'post_type'        => 'amp-optin',
			'post_status'      => 'publish',
			'posts_per_page' => -1,
		);
		$posts_array = get_posts( $args );
		$optin_posts = array();
		foreach( $posts_array as $cta ) {
			$optin_posts[ $cta->ID ] = $cta->post_title;
		}

		$sections[] = array(
					'title'      => __( 'Positon', 'redux-framework-demo' ),
					'desc'       => __( '', 'redux-framework-demo'),
					'id'				=> 'ampforwp-optin-subsection-shortcode',
					'subsection' => true,
								'fields'		=> array(

								array(
										'id'        => 'ampforwp-optin-box-position',
										'type'      => 'switch',
										'title'     => 'Automatically Show optin Box in content',
										'default'   =>  0,
										),
								array(
										'id'       => 'ampforwp-optin-box-selected-optin',
										'type'     => 'select',
										'title'    => __('Select a optin to display', 'accelerated-mobile-pages'),
										// Must provide key => value pairs for select options
										'options'  => $optin_posts,
										'required'  => array('ampforwp-optin-box-position','=','1'),
										'default'  => '1',
										),
								array(
										'id'        => 'ampforwp-optin-box-content-top',
										'type'      => 'switch',
										'title'     => 'Above Content',
										'default'   =>  0,
										'required'  => array('ampforwp-optin-box-position','=','1'),
										),
								array(
										'id'        => 'ampforwp-optin-box-content',
										'type'      => 'switch',
										'title'     => 'Between the 50% content',
										'default'   =>  0,
										'required'  => array('ampforwp-optin-box-position','=','1'),
										),
								array(
										'id'        => 'ampforwp-optin-box-content-bottom',
										'type'      => 'switch',
										'default'   =>  0,
										'required'  => array('ampforwp-optin-box-position','=','1'),
										'title'     => 'Below Content',
										),
						  		array(
					                    'id'      => 'amp-opt-in-posttype-support',
					                    'type'    => 'select',
					                    'title'   => esc_html__('Post Types'),
					                    'tooltip-subtitle'   => esc_html__('Enable AMP Support on required Post Types'),
					                    'multi'   => true,
					                    'required' => array('ampforwp-optin-box-position','=','1'),
					                    //'data' => 'post_type',
					                    'default' => ampforwp_supported_post_types_optin(isset($supported_types) ? $supported_types : ''),
					                    'options' => ampforwp_supported_post_types_optin(isset($supported_types) ? $supported_types : ''),
                ),
						        array(
					                    'id'        => 'ampforwp-exclude-optin-box-for-spec-post',
					                    'type'      => 'text',
					                    'multi'     => true,
					                    'default'   =>  0,
					                    'required'  => array('ampforwp-optin-box-position','=','1'),
					                    'title'     => 'Exclude Optin For Specific Posts',
					                    'desc'      => 'Enter the specific Post ID to exclude the AMP optin and if multiple posts then saparate them with a <b>comma ","</b> '
					                    ),
                                 array(
					                    'id'        => 'ampforwp-exclude-optin-box-for-spec-page',
					                    'type'      => 'text',
					                    'multi'     => true,
					                    'default'   =>  0,
					                    'required'  => array('ampforwp-optin-box-position','=','1'),
					                    'title'     => 'Exclude Optin For Specific Pages',
					                    'desc'      => 'Enter the specific Page ID to exclude the AMP optin and if multiple pages then saparate them with a <b>comma ","</b> '
					                    ),

								array(
				                       'id' => 'ampforwp-optin-popup-section',
				                       'type' => 'section',
				                       'title' => 'Pop-up Form',
				                       'indent' => true,       
                   				),

								array(
										'id'        => 'ampforwp-optin-form-popup',
										'type'      => 'switch',
										'title'     => 'Pop-up',
										'default'   =>  0,
										),
								array(
										'id'       => 'ampforwp-optin-popup-selected-optin',
										'type'     => 'select',
										'title'    => __('Select the optin', 'accelerated-mobile-pages'),
										'options'  => $optin_posts,
										'required' => array('ampforwp-optin-form-popup','=','1'),
										'default'  => '1',
										),

								array(
										'id'        => 'ampforwp-optin-popup-sec',
										'type'      => 'text',
										'default'   =>  '3s',
										'required'  => array('ampforwp-optin-form-popup','=','1'),
										'title'     => 'Seconds to delay the Pop-up',
										'desc'		=> 'When a user visits the site, It takes some seconds to pop-up the form( eg: 5s ).',
									),

								array(
				                       'id'     => 'ampforwp-optin-modal-section',
				                       'type'   => 'section',
				                       'title'  => 'Modal Form',
				                       'indent' => true,       
                   				),
                   				array(
                   						'id'	  => 'ampforwp-optin-modal-form',
                   						'type'	  => 'switch',
                   						'default' => 0,
                   						'title'	  => 'Modal'
                   				),
                   				array(
                   						'id'	   => 'ampforwp-optin-modal-button-text',
                   						'type'	   => 'text',
                   						'required' => array('ampforwp-optin-modal-form','=','1'),
                   						'title'    => 'Modal Button Text',
                   						'default'  => 'SUBSCRIBE',
                   				),
                   				array(
                   						'id'	=> 'ampforwp-optin-modal-button-position',
                   						'type' 	=> 'select',
                   						'title'	=> 'Button Position',
                   						'options' => array(
                   							'1' => __('Left', 'accelerated-mobile-pages' ),
                             				'2' => __('Bottom Left', 'accelerated-mobile-pages' ),
                             				'3' => __('Right', 'accelerated-mobile-pages' ),
                             				'4' => __('Bottom Right', 'accelerated-mobile-pages' ),
                   						),
                   						'required' => array('ampforwp-optin-modal-form','=','1'),
                   						'default' => '1',
                   				),

                   				array(
										'id'       => 'ampforwp-optin-modal-optin-select',
										'type'     => 'select',
										'title'    => __('Select the optin', 'accelerated-mobile-pages'),
										'options'  => $optin_posts, 
										'required' => array('ampforwp-optin-modal-form','=','1'),
										'default'  => '1',
										),
                   				array(
				                        'id'        => 'amp-optin-modal-button-bg-color',
				                        'type'      => 'color_rgba',
				                        'title'     => 'Button Background Color',
				                        'default'   => array( 'color' => '#f3f9fe'),
				                        'required' => array('ampforwp-optin-modal-form','=','1'),
		                        ),
		               			array(
				                        'id'        => 'amp-optin-modal-button-text-color',
				                        'type'      => 'color_rgba',
				                        'title'     => 'Button Text Color',
				                        'default'   => array(
				                                'color'     => '#0087E2'),
				                        'required' => array('ampforwp-optin-modal-form','=','1'),
		                        ),

							),
						);
	    return $sections;
	}
}


function ampforwp_get_cpt_generated_post_types_optin() {
    $options = '';
    $options = get_option('ampforwp_cpt_generated_post_types');
        return $options;
    }
 
add_filter('pre_amp_render_post','ampforwp_supported_post_types_optin');
function ampforwp_supported_post_types_optin($supported_types) {
  $supported_types = '' ;
  if(function_exists('ampforwp_get_all_post_types')){
	 $supported_types =  ampforwp_get_all_post_types();
	 unset($supported_types['category']);
	}
	return $supported_types;
}
add_filter("redux/options/redux_builder_amp/sections", 'ampoptin_settings_page', 100);