<?php
//add_action( 'add_meta_boxes', 'add_ampforwp_optin_size_metaboxes' );
function add_ampforwp_optin_size_metaboxes() {
	add_meta_box('ampforwp_optin_size', 'Optin Fields', 'ampforwp_optin_size_callback', 'amp-optin', 'normal', 'default');
}



add_action( 'add_meta_boxes', 'ampforwp_optin_add_shortcode_metabox' );

function ampforwp_optin_add_shortcode_metabox() {
	add_meta_box('ampforwp_cta_shortcode_metabox', 'Shortcode', 'ampforwp_optin_shortcode_metabox_callback', 'amp-optin', 'side', 'high');
}
function ampforwp_optin_shortcode_metabox_callback() {
	global $post;
	$ampforwp_optin_post_id = $post->ID;
    echo '<input type="text" class="widefat urlfield" readonly="readonly" value="[amp-optin id='. $ampforwp_optin_post_id .']">';
}
/**
 * Prints the box content.
 *
 * @param WP_Post $post The object for the current post/page.
 */
function ampforwp_optin_size_callback( $post ) {
	    // Add an nonce field so we can check for it later.
	    wp_nonce_field( 'ampforwp_optin_size_meta_box', 'ampforwp_optin_size_meta_box_nonce' );

    	// Fields
			$id = $post->ID;
			$submit_button 				   = get_post_meta( $id, 'amp_option_submit_button_text', true);
			$headline 						   = get_post_meta( $id, 'amp_option_headline_text', true);
			$description 						 = get_post_meta( $id, 'amp_option_description', true);
	    $amp_optin_form_selction = get_post_meta( $id, 'amp_option_form_selection', true); // Selection List ?>

			<!-- Form Selection List -->
			<div class="optin-form-fields optin-form-fields-company-name">
			<label for="amp-optin-select-form" class="amp-checkbox-label headline-text">Company</label>
				<select id="amp-optin-select-form" class="widefat"  name="amp_option_form_selection" value="<?php echo $amp_optin_form_selction; ?>">
				  <option value="1" <?php if( $amp_optin_form_selction == '1' ) { echo "selected"; } ?> >Mailchimp</option>
				  <option value="2" <?php if( $amp_optin_form_selction == '2' ) { echo "selected"; } ?> >Constant Contact</option>
<!--
				  <option value="3" <?php// if( $amp_optin_form_selction == '3' ) { echo "selected"; } ?> >GetResponse</option>
				  <option value="4" <?php// if( $amp_optin_form_selction == '4' ) { echo "selected"; } ?> >CampaginMonitor </option>
				  <option value="5" <?php// if( $amp_optin_form_selction == '5' ) { echo "selected"; } ?> >MailerLite</option>
-->
				</select>
			</div>
			<!-- Form Selection List -->


 
			<!---  Form -1 -->
				<?php require_once AMPOPTIN_PLUGIN_DIR . 'meta-fields/form-1-fields.php';  ?>
			<!--  Form -1 -->

			<!--  Form -2 -->
				<?php require_once AMPOPTIN_PLUGIN_DIR . 'meta-fields/form-2-fields.php';  ?>
			<!--  Form -2 -->

			<!--  Form -3 -->
				<?php require_once AMPOPTIN_PLUGIN_DIR . 'meta-fields/form-3-fields.php';  ?>
			<!--  Form -3 -->

			<!--  Form -4 -->
				<?php require_once AMPOPTIN_PLUGIN_DIR . 'meta-fields/form-4-fields.php';  ?>
			<!--  Form -4 -->

			<!--  Form -5 -->
				<?php require_once AMPOPTIN_PLUGIN_DIR . 'meta-fields/form-5-fields.php';  ?>
			<!--  Form -5 -->


			<div class="optin-form-fields optin-form-fields-headline">
			<label for="amp_option_headline_text" class="amp-checkbox-label headline-text">Title</label>
		    <input id="amp_option_headline_text" type="text" placeholder="Title" name="amp_option_headline_text" class="ampforwp-text-field" value="<?php echo esc_attr($headline); ?>">
            </div>

 			<div class="optin-form-fields optin-form-fields-description">
				<label for="amp_option_description" class="amp-checkbox-label description-text">Description</label>
		    <input id="amp_option_description" type="text" placeholder="Description" name="amp_option_description" class="ampforwp-text-field" value="<?php echo esc_attr($description); ?>">
            </div>
		<!-- Form Submit Button -->
		<div class="optin-form-fields optin-form-fields-submit-button">
			<label for="amp-optin-submit-button-text" class="amp-checkbox-label sumbit-button">Submit Button</label>
	    <input id="amp-optin-submit-button-text" type="text" placeholder="Submit" name="amp_option_submit_button_text" class="ampforwp-text-field" value="<?php echo esc_attr($submit_button); ?>">
    </div>
		<!-- Form Submit Button --> <?php
}

// Utility code for making this check DRY and easily modifiable
// @param $checked -> got from the form
function ampforwp_optin_is_checked( $checked ){
 	if( $checked == 'yes' ) {
		echo 'checked';
	}
}

/**
 * When the post is saved, saves our custom data.
 *
 * @param int $post_id The ID of the post being saved.
 */
function ampforwp_optin_size_save_data( $post_id ) {

    /*
     * We need to verify this came from our screen and with proper authorization,
     * because the save_post action can be triggered at other times.
     */
    // Check if our nonce is set.
	    if ( !isset( $_POST['ampforwp_optin_size_meta_box_nonce'] ) ) {
	        return;
	    }
    // Verify that the nonce is valid.
	    if ( !wp_verify_nonce( $_POST['ampforwp_optin_size_meta_box_nonce'], 'ampforwp_optin_size_meta_box' ) ) {
	        return;
	    }
    // If this is an autosave, our form has not been submitted, so we don't want to do anything.
	    if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) {
	        return;
	    }
    // Check the user's permissions.
	    if ( !current_user_can( 'edit_post', $post_id ) ) {
	        return;
	    }
    // Sanitize user input.
		$list_form_selection 		= ( isset( $_POST['amp_option_form_selection'] ) ? $_POST['amp_option_form_selection']  : '' );
		$submit_button 	= ( isset( $_POST['amp_option_submit_button_text'] ) ?  esc_attr( $_POST['amp_option_submit_button_text'] )  : '' );
		$headline 	= ( isset( $_POST['amp_option_headline_text'] ) ?  esc_attr( $_POST['amp_option_headline_text'] )  : '' );
		$description 	= ( isset( $_POST['amp_option_description'] ) ?  esc_attr( $_POST['amp_option_description'] )  : '' );

		if( $list_form_selection == '1' ) {
			$list_url 			= ( isset( $_POST['amp_option_list_url'] ) ?  $_POST['amp_option_list_url']  : '' );
			$first_name 		=  ( isset( $_POST['amp_option_first_name'] ) ?  esc_attr( $_POST['amp_option_first_name'] )  : '' );
			$last_name 			= ( isset( $_POST['amp_option_last_name'] ) ?  esc_attr( $_POST['amp_option_last_name'] )  : '' );
			$email_address 	= ( isset( $_POST['amp_option_email_address'] ) ?  esc_attr( $_POST['amp_option_email_address'] )  : '' );
			// Checkbox
			$first_name_cbx_form_1 		  = ( isset( $_POST['amp_option_first_name_form_1_checkbox'] ) ?  esc_attr( $_POST['amp_option_first_name_form_1_checkbox'] )  : '' );
			$last_name_cbx_form_1 		    = ( isset( $_POST['amp_option_last_name_form_1_checkbox'] ) ?  esc_attr( $_POST['amp_option_last_name_form_1_checkbox'] )  : '' );
			$email_cbx_form_1 		        = ( isset( $_POST['amp_option_email_address_form_1_checkbox'] ) ?  esc_attr( $_POST['amp_option_email_address_form_1_checkbox'] )  : '' );

    	// Update the meta field in the database.
	    update_post_meta( $post_id, 'amp_option_first_name_form_1_checkbox', 	$first_name_cbx_form_1 );
	    update_post_meta( $post_id, 'amp_option_last_name_form_1_checkbox', 	$last_name_cbx_form_1 );
	    update_post_meta( $post_id, 'amp_option_email_address_form_1_checkbox', 	$email_cbx_form_1 );
	    update_post_meta( $post_id, 'amp_option_list_url', 	$list_url );
	    update_post_meta( $post_id, 'amp_option_first_name', $first_name );
	    update_post_meta( $post_id, 'amp_option_last_name', $last_name );
	    update_post_meta( $post_id, 'amp_option_email_address', $email_address );
		}

		if( $list_form_selection == '2' ) {
			$url				 =  ( isset( $_POST['amp_option_from_2_url'] ) ?   $_POST['amp_option_from_2_url']   : '' );
			$required		 =  ( isset( $_POST['amp_option_from_2_required'] ) ?  esc_attr( $_POST['amp_option_from_2_required'] )  : '' );
			$source			 =  ( isset( $_POST['amp_option_from_2_source'] ) ?  esc_attr( $_POST['amp_option_from_2_source'] )  : '' );
			$ca				   =  ( isset( $_POST['amp_option_from_2_ca'] ) ?  esc_attr( $_POST['amp_option_from_2_ca'] )  : '' );
			$first_name	 =  ( isset( $_POST['amp_option_from_2_first_name'] ) ?  esc_attr( $_POST['amp_option_from_2_first_name'] )  : '' );
			$email			 =  ( isset( $_POST['amp_option_form_2_email'] ) ?  esc_attr( $_POST['amp_option_form_2_email'] )  : '' );
			// Checkbox
		  $first_name_cbx_form_2 		  	=  ( isset( $_POST['amp_option_first_name_form_2_checkbox'] ) ?  esc_attr( $_POST['amp_option_first_name_form_2_checkbox'] )  : '' );
		  $last_name_cbx_form_2 		    =  ( isset( $_POST['amp_option_last_name_form_2_checkbox'] ) ?  esc_attr( $_POST['amp_option_last_name_form_2_checkbox'] )  : '' );
		  $email_cbx_form_2 		        =  ( isset( $_POST['amp_option_email_address_form_2_checkbox'] ) ?  esc_attr( $_POST['amp_option_email_address_form_2_checkbox'] )  : '' );

    	// Update the meta field in the database.
	    update_post_meta( $post_id, 'amp_option_first_name_form_2_checkbox', 	$first_name_cbx_form_2 );
	    update_post_meta( $post_id, 'amp_option_last_name_form_2_checkbox', 	$last_name_cbx_form_2 );
	    update_post_meta( $post_id, 'amp_option_email_address_form_2_checkbox', 	$email_cbx_form_2 );
	    update_post_meta( $post_id, 'amp_option_from_2_url', 	$url );
	    update_post_meta( $post_id, 'amp_option_from_2_required', 	$required );
	    update_post_meta( $post_id, 'amp_option_from_2_source', $source );
	    update_post_meta( $post_id, 'amp_option_from_2_ca', $ca );
	    update_post_meta( $post_id, 'amp_option_from_2_first_name', $first_name );
	    update_post_meta( $post_id, 'amp_option_form_2_email', $email );
		}

		if( $list_form_selection == '3' ) {
			$campaign_token		  =  ( isset( $_POST['amp_option_from_3_campaign_token'] ) ?  esc_attr( $_POST['amp_option_from_3_campaign_token'] )  : '' );
			$first_name  				=  ( isset( $_POST['amp_option_from_3_first_name'] ) ?  esc_attr( $_POST['amp_option_from_3_first_name'] )  : '' );
			$email 			 				=  ( isset( $_POST['amp_option_form_3_email'] ) ?  esc_attr( $_POST['amp_option_form_3_email'] )  : '' );
			$list_url           =  ( isset( $_POST['amp_option_form_3_url'] ) ?   $_POST['amp_option_form_3_url']   : '' );
			$first_name_cbx_form_3      =  ( isset( $_POST['amp_option_first_name_form_3_checkbox'] ) ?   $_POST['amp_option_first_name_form_3_checkbox']   : '' );
			$email_cbx_form_3           =  ( isset( $_POST['amp_option_email_address_form_3_checkbox'] ) ?   $_POST['amp_option_email_address_form_3_checkbox']   : '' );

			// Update the meta field in the database.
	    update_post_meta( $post_id, 'amp_option_first_name_form_3_checkbox', 	$first_name_cbx_form_3 );
	    update_post_meta( $post_id, 'amp_option_email_address_form_3_checkbox', 	$email_cbx_form_3 );
	    update_post_meta( $post_id, 'amp_option_from_3_campaign_token', 	$campaign_token );
	    update_post_meta( $post_id, 'amp_option_from_3_first_name', 	$first_name );
	    update_post_meta( $post_id, 'amp_option_form_3_email', $email );
	    update_post_meta( $post_id, 'amp_option_form_3_url', $list_url );
		}

		if( $list_form_selection == '4' ) {
			$first_name  				=  ( isset( $_POST['amp_option_from_4_first_name'] ) ?  esc_attr( $_POST['amp_option_from_4_first_name'] )  : '' );
			$email 			 				=  ( isset( $_POST['amp_option_form_4_email'] ) ?  esc_attr( $_POST['amp_option_form_4_email'] )  : '' );
			$list_url           =  ( isset( $_POST['amp_option_form_4_url'] ) ?   $_POST['amp_option_form_4_url']  : '' );
			$first_name_cbx_form_4      =  ( isset( $_POST['amp_option_first_name_form_4_checkbox'] ) ?   $_POST['amp_option_first_name_form_4_checkbox']  : '' );
			$email_cbx_form_4           =  ( isset( $_POST['amp_option_email_address_form_4_checkbox'] ) ?   $_POST['amp_option_email_address_form_4_checkbox']  : '' );

			// Update the meta field in the database.
	    update_post_meta( $post_id, 'amp_option_first_name_form_4_checkbox', 	$first_name_cbx_form_4 );
	    update_post_meta( $post_id, 'amp_option_email_address_form_4_checkbox', 	$email_cbx_form_4 );
	    update_post_meta( $post_id, 'amp_option_from_4_first_name', 	$first_name );
	    update_post_meta( $post_id, 'amp_option_form_4_email', 	$email );
	    update_post_meta( $post_id, 'amp_option_form_4_url', $list_url );
		}

		if( $list_form_selection == '5' ) {
			$ml_submit		  			=  ( isset( $_POST['amp_option_from_5_ml_submit'] ) ?  esc_attr( $_POST['amp_option_from_5_ml_submit'] )  : '' );
			$first_name  					=  ( isset( $_POST['amp_option_from_5_first_name'] ) ?  esc_attr( $_POST['amp_option_from_5_first_name'] )  : '' );
			$email 			 					=  ( isset( $_POST['amp_option_form_5_email'] ) ?  esc_attr( $_POST['amp_option_form_5_email'] )  : '' );
			$company 			 				=  ( isset( $_POST['amp_option_form_5_company'] ) ?  esc_attr( $_POST['amp_option_form_5_company'] )  : '' );
			$list_url             =  ( isset( $_POST['amp_option_form_5_url'] ) ?  $_POST['amp_option_form_5_url']  : '' );
			$first_name_cbx_form_5             =  ( isset( $_POST['amp_option_first_name_form_5_checkbox'] ) ?  $_POST['amp_option_first_name_form_5_checkbox']  : '' );
			$company_cbx_form_5             =  ( isset( $_POST['amp_option_company_form_5_checkbox'] ) ?  $_POST['amp_option_company_form_5_checkbox']  : '' );
			$email_cbx_form_5             =  ( isset( $_POST['amp_option_email_address_form_5_checkbox'] ) ?  $_POST['amp_option_email_address_form_5_checkbox']  : '' );

			// Update the meta field in the database.
	    update_post_meta( $post_id, 'amp_option_first_name_form_5_checkbox', 	$first_name_cbx_form_5 );
	    update_post_meta( $post_id, 'amp_option_company_form_5_checkbox', 	$company_cbx_form_5 );
	    update_post_meta( $post_id, 'amp_option_email_address_form_5_checkbox', 	$email_cbx_form_5 );
	    update_post_meta( $post_id, 'amp_option_from_5_ml_submit', 	$ml_submit );
	    update_post_meta( $post_id, 'amp_option_from_5_first_name', 	$first_name );
	    update_post_meta( $post_id, 'amp_option_form_5_email', $email );
	    update_post_meta( $post_id, 'amp_option_form_5_company', $company );
	    update_post_meta( $post_id, 'amp_option_form_5_url', $list_url );
		}

		update_post_meta( $post_id, 'amp_option_headline_text', $headline );
		update_post_meta( $post_id, 'amp_option_description', $description );
		update_post_meta( $post_id, 'amp_option_submit_button_text', $submit_button );
		update_post_meta( $post_id, 'amp_option_form_selection', 	$list_form_selection );
}
//add_action( 'save_post', 'ampforwp_optin_size_save_data' );

// Styling of Meta Boxes
add_action('admin_footer','amp_optin_fields_style');
function amp_optin_fields_style () { ?>
<style>.cmb-th{font-weight: normal} #ampforwp_optin_size{display: none}
    .cmb2-wrap{margin-left: 20px !important}
    .cmb-type-title{margin-top: 18px !important;}
    .cmb2-metabox-title{margin-bottom: 0}
    .cmb-type-group .cmb-row, .cmb2-postbox .cmb-row{margin: 0;padding:14px 0px 14px 0px !important;border-color:#efefef !important}
    .cmb2-id-amp-optin-form-1-API-URL label:after{content: "*";color: #ff8a65;margin-left: 3px;}
    .cmb2-metabox-title{font-size: 16px;}
    body .cmb2-postbox .amp_optin_form_tutorial{ border: 0 !important;margin-top: 10px !important;padding: 0 !important;}
    
</style> 
<?php }