<?php
// Our custom post type function
function ampforwp_create_optin_posttype() {
    register_post_type( 'amp-optin',
    // CPT Options
        array(
            'labels' => array(
                'name'              => __( 'AMP Optin' ),
                'singular_name'     => __( 'AMP Optin' ),
                'add_new'           => __( 'Add New Optin' ),
                'add_new_item'      => __( 'Add New Optin' ),
                'edit_item'         => __( 'Edit Optin' ),
                'new_item'          => __( 'Add New Optin' ),
                'view_item'         => __( 'View Optin' ),
                'search_items'      => __( 'Search Optin' ),
                'not_found'         => __( 'No optins found' ),
                'not_found_in_trash'=> __( 'No optins found in trash' )
            ),
            'public'                => true,
            'has_archive'           => false,
            'rewrite'               => array('slug' => 'amp-optin'),
            'supports'              => array( 'title' ),
            'publicly_queryable' => false
        )
    );
}
add_action( 'init', 'ampforwp_create_optin_posttype' );



require_once AMPOPTIN_PLUGIN_DIR . 'meta-fields/meta-fields.php';
require_once AMPOPTIN_PLUGIN_DIR . 'meta-fields/meta-color.php';

// require_once AMPOPTIN_PLUGIN_DIR . '/form-sanitizer.php';

// Field in AMP optin edit page
add_filter( 'manage_amp-optin_posts_columns', 'set_custom_edit_amp_optin_columns' );
add_action( 'manage_amp-optin_posts_custom_column' , 'custom_amp_optin_column', 10, 2 );

function set_custom_edit_amp_optin_columns($columns) {
    $columns['amp-optin-shortcode-output'] = __( 'Optin Form Code', 'amp-optin' );
    return $columns;
}

function custom_amp_optin_column( $column, $post_id ) {
    switch ( $column ) {

        case 'amp-optin-shortcode-output' :
            $terms = '<input type="text" class="urlfield" readonly="readonly" value="[amp-optin id= '. $post_id .' ]">';
            if ( is_string( $terms ) )
                echo $terms;
            else
                _e( 'Unable to get shortcode(s)', 'your_text_domain' );
        break;

    }
}



add_action( 'admin_enqueue_scripts', 'ampforwp_optin_color_picker' );
function ampforwp_optin_color_picker( $hook ) {

    if( is_admin() ) {

        // Add the color picker css file
        wp_enqueue_style( 'wp-color-picker' );

        // Include our custom jQuery file with WordPress Color Picker dependency
        wp_enqueue_script( 'custom-script-handle', plugins_url( 'js/custom-script.js', __FILE__ ), array( 'wp-color-picker' ), false, true );

    }
}