<?php
/**
 * The main template file
 *
 * This is the most generic template file in a WordPress theme
 * and one of the two required files for a theme (the other being style.css).
 * It is used to display a page when nothing more specific matches a query.
 * E.g., it puts together the home page when no home.php file exists.
 *
 * @link https://developer.wordpress.org/themes/basics/template-hierarchy/
 *
 * @package gproslaw
 */
get_header();
    $h1 = (get_field('h1',get_option('page_for_posts'))) ? get_field('h1',get_option('page_for_posts')) : get_the_title(get_option('page_for_posts'));
    

    if ( have_posts() ) {
        global $wp_query;
        if (is_home() && !is_front_page()) { ?>
        <?php /*?>$fe_img = (get_the_post_thumbnail_url()) ? get_the_post_thumbnail_url(get_option('page_for_posts')) : get_field('default_banner','option');<?php */?>
            <div class="banner-main innerpage-banner">
                <canvas id="glscreen"></canvas>
                <div class="banner-inner"
                     <?php /*?>style="background: url(<?php echo $fe_img; ?>) no-repeat; background-position: center; background-size: cover;"<?php */?>>
                    <div class="banner-content wow fadeInUp">
                        <div class="container container-2">
                            <div class="banner-text">
                                <h1 class="text-noeffect">
                                    <figure><?php echo $h1; ?></figure>
                                </h1>
                            </div>
                        </div>
                    </div>
					<div class="bi-btn-main"><a href="#ft-form">start your <span>FREE</span> consultation</a></div>
                </div>
            </div>
        <?php
        } ?>
        <?php echo do_shortcode('[breadcrumbs]');?>
            <div class="middle-content dc-content-main">
                <div class="default-section dc-2 dc-bg">
                    <div class="container container-2">
                        <div class="blog-box-main">
                            <h2><?php echo get_the_title(get_option('page_for_posts'));?></h2>
                            <div class="row">
                                <div class="col-sm-8 col-xs-12">
                                    <div class="blog-list">
                                        <div class="row" id="main">
                                            <?php
                                            while (have_posts()) { the_post();
                                                get_template_part('template-parts/content', get_post_type());
                                            }
                                            //if (  $wp_query->max_num_pages > 1 )
                                            //	echo '<div class="misha_loadmore loading"><span>More posts</span></div>'; // you can use <a> as well
                                            
                                            the_posts_pagination( array(
                                                'screen_reader_text' => '',
                                                'prev_text'          => __( '<', 'gproslaw' ),
                                                'next_text'          => __( '>', 'gproslaw' ),
                                            ) );  ?>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-sm-4 col-xs-12">
                                    <div class="sidebar-main">
                                        <?php get_sidebar();?>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
    <?php
    }
    else {
        get_template_part('template-parts/content', 'none');
    }

get_footer();