<?php
/**
 * The template for displaying search results pages
 *
 * @link https://developer.wordpress.org/themes/basics/template-hierarchy/#search-result
 *
 * @package gproslaw
 */

get_header(); ?>
    <div class="middle-content dc-content-main">
        <div class="default-section dc-2 dc-bg">
            <div class="container container-2">
                <div class="blog-box-main">
                    <?php
                    if ( have_posts() ) { ?>
                        <h2>
                            <?php
                            printf(esc_html__('Search Results for: %s', 'gproslaw'), '<span>' . get_search_query() . '</span>'); ?>
                        </h2>
                        <div class="row">
                            <div class="col-sm-12 col-xs-12">
                                <div class="blog-list">
                                    <div class="row">
                                        <?php
                                        while (have_posts()) { the_post();
                                            get_template_part('template-parts/content', 'search');
                                        }
                                        the_posts_pagination( array(
                                            'screen_reader_text' => '',
                                            'prev_text'          => __( '<', 'gproslaw' ),
                                            'next_text'          => __( '>', 'gproslaw' ),
                                        ) );?>
                                    </div>
                                </div>
                            </div>
                        </div>
                    <?php
                    }
                    else{
                        get_template_part('template-parts/content', 'none');
                    } ?>
                </div>
            </div>
        </div>
    </div>
<?php
get_footer();